<?php
namespace Teknisa\FAI\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Fai01200ConhecimentoFornecimento extends \Zeedhi\Framework\Controller\Report {

    protected $newCode;
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $environment;
    protected $procedureRelGesDireta;

    public function __construct(ReportService $reportService, $newCode, $qr2Strategy, $birtStrategy, $environment, $connection, StoredProcedure $procedureRelGesDireta) {
        $this->reportService = $reportService;
        $this->newCode       = $newCode;
        $this->qr2Strategy   = $qr2Strategy;
        $this->birtStrategy   = $birtStrategy;
        $this->environment   = $environment;
        $this->connection    = $connection;
        $this->procedureRelGesDireta = $procedureRelGesDireta;
    }

    protected $reportMapping = array (
        'FAI01200' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'DTCDRS'      => 'P_DTCDRS',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',
                'NRORG'       => 'P_NRORG'
            ),
        ),
        'FAI01201' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'DTCDRS'      => 'P_DTCDRS',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',

            ),
        ),
        'FAI01202' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'DTCDRS'      => 'P_DTCDRS',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',

            ),
        ),
        'FAI01203' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'DTCDRS'      => 'P_DTCDRS',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',

            ),
        ),
        'FAI01208' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',

            ),
        ),
        'FAI01209' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',

            ),
        ),
        'FAI01210' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',

            ),
        ),
        'FAI01211' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'CDFILIAL'    => 'P_CDFILIAL',
                'NRAPURACGD'  => 'P_NRAPURACGD',
                'CDCLIENTE'   => 'P_CDCLIENTE',
                'TCDCLIENTE'  => 'P_TCDCLIENTE',
                'DATAINI'     => 'P_DATAINI',
                'DATAFIN'     => 'P_DATAFIN',
                'DTINICIAL'   => 'P_DTINICIAL',
                'DTFINAL'     => 'P_DTFINAL',
                'DTFINALCOMP' => 'P_DTFINALCOMP',
                'DTCDRS'      => 'P_DTCDRS',
                'CDGRUPSERV'  => 'P_CDGRUPSERV',

            ),
        ),
    );

    private function isCentralUnit($cdfilial){
        $sql = <<<SQL
            SELECT IDCENTRALFATU 
            FROM FILIAL 
            WHERE 
                CDFILIAL = :P_CDFILIAL 
                AND NRORG = :P_NRORG
SQL;
        $stmt = $this->connection->prepare($sql);
        $stmt->execute(array(
            'P_CDFILIAL' => $cdfilial,
            'P_NRORG'    => $this->environment->getNrOrg()
        ));
        $result = $stmt->fetch();
        if(!empty($result) && is_array($result) && isset($result['IDCENTRALFATU'])){
            return $result['IDCENTRALFATU'] == 'S';
        }
        return false;
    }

    // FAI01201 E FAI01202 são .CDS
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['NRORG']    = $this->environment->getNrOrg();
        $isCentralUnit = $this->isCentralunit($row['CDFILIAL']);
        $reportCode = $row['__report_name'];
        $seqRelat = $this->newCode->getCodeByTableName('RELAPURFAT'.$row['CDFILIAL'], $row['NRORG']);
        if(in_array($reportCode, ["FAI01200","FAI01203"])) {
            $seq = $this->retornaSequencial($row);
            if($seq == null) {
                $seqNextCode = $this->newCode->getCodeByTableName('NUMECDRS', $row['NRORG']);
                $this->insereCDRS($row, $seqNextCode, $seqRelat);
            }
        }
        $nextCode = $this->newCode->getCodeByTableName('APURACFATUR'.$row['CDFILIAL'], $row['NRORG']);
        $row['NRAPURACGD'] = $nextCode;
        $row['DATAINI']    = $row['DTINICIAL'];
        $row['DATAFIN']    = $row['DTFINAL'];
        $P_CENTRAL = $isCentralUnit ? 'S' : 'N';
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->procedureRelGesDireta->addParam(new Param('P_FILIAL',       Param::PARAM_INPUT, $row['CDFILIAL'],    Param::PARAM_TYPE_STR));
        $this->procedureRelGesDireta->addParam(new Param('P_DATAINI',      Param::PARAM_INPUT, $row['DTINICIAL'],   Param::PARAM_TYPE_STR));
        $this->procedureRelGesDireta->addParam(new Param('P_DATAFIN',      Param::PARAM_INPUT, $row['DTFINAL'],     Param::PARAM_TYPE_STR));
        $this->procedureRelGesDireta->addParam(new Param('P_NRAPURACGD',   Param::PARAM_INPUT, $row['NRAPURACGD'],  Param::PARAM_TYPE_STR));
        $this->procedureRelGesDireta->addParam(new Param('P_CDCLIENTE',    Param::PARAM_INPUT, null,                Param::PARAM_TYPE_NULL));
        $this->procedureRelGesDireta->addParam(new Param('P_EQUIVALENCIA', Param::PARAM_INPUT, 'N',                 Param::PARAM_TYPE_NULL));
        $this->procedureRelGesDireta->addParam(new Param('P_CENTRAL',      Param::PARAM_INPUT, $P_CENTRAL,          Param::PARAM_TYPE_NULL));
        $this->procedureRelGesDireta->execute();
    }

    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
        $row = $request->getRow();
        $reportCode = $row['__report_name'];
        $strategy = $this->reportMapping[$reportCode]['strategy'];
        if($strategy === 'QR2'){
            $this->deleteTrabApuracGD($row['NRAPURACGD'], $row['CDFILIAL']);
        }
    }

    private function deleteTrabApuracGD($nrapuracentral, $cdfilial){
        $sql = <<<SQL
        DELETE FROM TRAB_APURAC_GD
                WHERE CDFILIALCENTRAL = :P_CDFILIALCENTRAL  AND
                      NRAPURACENTRAL  = :P_NRAPURACENTRAL   AND
                      NRORG           = :P_NRORG
SQL;
        $params = array(
            'P_CDFILIALCENTRAL' => $cdfilial,
            'P_NRAPURACENTRAL'  => $nrapuracentral,
            'P_NRORG'           => $this->environment->getNrOrg()
        );
        $stmt = $this->connection->prepare($sql);
        $stmt->execute($params);
    }

    public function retornaSequencial($row) {
        $sql = "SELECT NRCDRS
        FROM RELAT_CDRS
        WHERE CDFILIAL = :P_CDFILIAL
        AND DTCDRS = :P_DTCDRS";
        $params = array(
            'P_CDFILIAL' => $row['CDFILIAL'],
            'P_DTCDRS'   => $row['DTCDRS']
        );
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $dataSet = $query->fetchAll();
        return $dataSet;
    }

    public function insereCDRS($row, $seq, $seqRelat) {
        $sql = "INSERT INTO RELAT_CDRS
        (CDFILIAL, CDCLIENTE, NRCDRS, CDSERVFILI, DTCDRS, NRQUINZENA, CDPRODUTO, VRPRECUNIT)
        (SELECT DISTINCT TA.CDFILIALAPGD, TA.CDCLIENTEAPGD, :P_NRCDRS, TA.CDSERVFILIAPGD, :P_DTCDRS, :P_NRQUINZENA, TA.CDPRODUTOAPGD, 0
        FROM TRAB_APURAC_GD TA
        WHERE (TA.CDFILIALAPGD = :P_CDFILIALAPGD)
        AND (TA.NRAPURACGD = :P_NRAPURACGD)
        AND ((INSTR(:P_CDCLIENTEAPGD, '_'||TA.CDCLIENTEAPGD||'_') > 0) OR (:P_CDCLIENTEAPGD = 'T' )))";
        $params = array(
            'P_NRCDRS'        => $seq,
            'P_DTCDRS'        => $row['DTCDRS'],
            'P_NRQUINZENA'    => $row['QUINZENA'],
            'P_CDFILIALAPGD'  => $row['CDFILIAL'],
            'P_NRAPURACGD'    => $seqRelat,
            'P_CDCLIENTEAPGD' => 'T'
        );
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}